-----------------------------------------------------------------------------------------------
-- Client Lua Script for Shut_The_Bleep_Up
-- Copyright (c) Arujei. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "ChatSystemLib"
 
-----------------------------------------------------------------------------------------------
-- Shut_The_Bleep_Up Module Definition
-----------------------------------------------------------------------------------------------
local Shut_The_Bleep_Up = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
local maxVolume = 1.0
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Shut_The_Bleep_Up:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
	self.savedVolumes = {
		["voice"] = Apollo.GetConsoleVariable("sound.volumeVoice")
	}	
    return o
end

function Shut_The_Bleep_Up:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- Shut_The_Bleep_Up OnLoad
-----------------------------------------------------------------------------------------------
function Shut_The_Bleep_Up:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("Shut_The_Bleep_Up.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	Apollo.RegisterEventHandler("UI_HealthChanged", "OnSound_Mute_Voice", self)
end

-----------------------------------------------------------------------------------------------
-- Shut_The_Bleep_Up OnDocLoaded
-----------------------------------------------------------------------------------------------
function Shut_The_Bleep_Up:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "Shut_The_Bleep_UpForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
		self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		self.xmlDoc = nil

	end
end

function Shut_The_Bleep_Up:OnSave(saveLevel)
	if saveLevel ~= GameLib.CodeEnumAddonSaveLevel.Account then
        return nil
    end
	local saveData = {
		Volumes = {
			["voice"] = self.savedVolumes["voice"]
		},
		MuteSettings = {
			IsVoiceMuted = self.muteSettings["voice"]
		}
	}
	return saveData
end

function Shut_The_Bleep_Up:OnRestore(saveLevel, savedData)
	if saveLevel ~= GameLib.CodeEnumAddonSaveLevel.Account then
		return nil
	end
	
	if savedData.Volumes ~= nil then
	
		if savedData.Volumes["voice"] ~= nil then
			self.savedVolumes["voice"] = savedData.Volumes["voice"]
		end
	
	end
	
	if savedData.MuteSettings ~= nil then
		if savedData.MuteSettings.IsVoiceMuted ~= nil then
			self.muteSettings["voice"] = savedData.MuteSettings.IsVoiceMuted 
		end
	end

	
	
	self:SetVolume()
end

-----------------------------------------------------------------------------------------------
-- Shut_The_Bleep_Up Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on Death 
function Shut_The_Bleep_Up:OnSound_Mute_Voice(current, max)
	if current <= 0 then

		self.savedVolumes["voice"] = Apollo.GetConsoleVariable("sound.volumeVoice")
		Apollo.SetConsoleVariable("sound.volumeVoice", 0)
		tTimer = ApolloTimer.Create(1, true, "OnTimer", self)
		tTimer:Start()

	end
end

function Shut_The_Bleep_Up:OnTimer()
	local unit = GameLib.GetPlayerUnit()

	if unit:GetHealth() >= 1 then

		tTimer:Stop()
		tTimer2 = ApolloTimer.Create(10, false, "OnTimer2", self)
		tTimer2:Start()

	end
end

function Shut_The_Bleep_Up:OnTimer2()
		Apollo.SetConsoleVariable("sound.volumeVoice", self.savedVolumes["voice"])
		tTimer2:Stop()
end

-----------------------------------------------------------------------------------------------
-- Shut_The_Bleep_UpForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function Shut_The_Bleep_Up:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function Shut_The_Bleep_Up:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- Shut_The_Bleep_Up Instance
-----------------------------------------------------------------------------------------------
local Shut_The_Bleep_UpInst = Shut_The_Bleep_Up:new()
Shut_The_Bleep_UpInst:Init()
